﻿using System;
using System.Collections;
using System.Collections.Generic;

namespace GenericLibrary
{
    class Program
    {
        public static void Main(string[] args)
        {
            ICatalog<int, Student> students = new CatalogList<int, Student>();
            Student st1 = new Student(1, "Anders");
            Student st2 = new Student(23, "John");
            students.Add(st1);
            students.Add(st2);
            IEnumerable<Student> coll = students.GetAll();
            IList<Student> coll2 = coll as IList<Student>;
            if (coll2 != null)
            {
                coll2.Add(st1);
                Console.WriteLine(students);
            }

        }
    }

    class Student : IIdentifiable<int>
    {
        public int Id { get; private set; }
        public String Name { get; set; }

        public Student(int id, string name)
        {
            Id = id;
            Name = name;
        }

        public override string ToString()
        {
            return Id + ": " + Name;
        }
    }
}
